<?php

require 'classes/Quest.php';
require 'classes/AddReward.php';
require 'classes/RechargeActivity.php';

class EquipController{

    protected function getMysql($account_id)
    {
        $mysql_conf = getMysqlConfig(crc32($account_id));
        $conn = new phpcommon\Mysql(array(
            'host' => $mysql_conf['host'],
            'port' => $mysql_conf['port'],
            'user' => $mysql_conf['user'],
            'passwd' => $mysql_conf['passwd'],
            'dbname' => DBNAME_PREFIX . $mysql_conf['instance_id']
        ));
        return $conn;
    }

    protected function getItem($item_id)
    {
        $g_conf_item_cluster = require('../res/item@item.php');
        $item_conf = getItemConfig($g_conf_item_cluster, $item_id);
        $it = array(
            'id' => $item_conf['id'],
            'diamond' => $item_conf['diamond'],
            //'dprice' => $item_conf['dprice'],
            'type' => $item_conf['fuction'],
            'diamond_hour' => $item_conf['diamond_hour']
        );
        return $it;
    }

    protected function getParameter($para_id)
    {
        $g_conf_para_cluster = require('../res/parameter@parameter.php');
        $para_conf = getParameterConfig($g_conf_para_cluster, $para_id);
        $p = array(
            'id' => $para_conf['id'],
            'param_name' => $para_conf['param_name'],
            'param_value' => $para_conf['param_value'],
        );
        return $p;
    }

    protected function getEquip($equip_id)
    {
        $g_conf_equip_cluster = require('../res/equip@equip.php');
        $equip_conf = getEquipConfig($g_conf_equip_cluster, $equip_id);
        if (!$equip_conf) {
            return null;
        }
        $e = array(
            'id' => $equip_conf['id'],
            'upgrade_priority' => $equip_conf['upgrade_priority'],
            'equip_upgrade' => $equip_conf['equip_upgrade'],
            'level_gold_cost' => $equip_conf['level_gold_cost'],
            'max_level' => $equip_conf['max_level'],
            'equip_upgradematerial' => $equip_conf['equip_upgradematerial'],
            'equip_upgradetime' => $equip_conf['equip_upgradetime'],
            'diamond_cost' => $equip_conf['diamond_cost'],
            'reduce_time' => $equip_conf['reduce_time'],
            'diamond_time' => $equip_conf['diamond_time'],
            'upgrade_gold' => $equip_conf['upgrade_gold'],
            'promote_gold' => $equip_conf['promote_gold'],
            'promote_material' => $equip_conf['promote_material'],
            'real_index_id' => $equip_conf['real_index_id'],
        );
        return $e;
    }

    protected function getExplode($string)
    {
        $delim = "|";
        $drop_multiply = explode($delim, $string);
        $delim1 = ":";
        $arr = array();
        for ($i = 0; $i < count($drop_multiply); $i++) {
            $mul = explode($delim1, $drop_multiply[$i]);
            array_push($arr, $mul);
        }
        return $arr;
    }

    public function equipInfo()
    {
        $account_id = $_REQUEST['account_id'];

        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $equip_list = array();
        $rows = $conn->execQuery('SELECT * FROM equip WHERE accountid=:account_id;',
                                    array(
                                        'account_id' => $account_id,
                                    ));
        $addreward = new classes\AddReward();
        if (!$rows) {
            //新玩家装备数据
            $id = $addreward->getRealIndexid(12151, $account_id);
            $ret = $conn->execScript('INSERT INTO equip(accountid, id, lv, active_time, sub_time, create_time, modify_time, using_id, exp) ' .
                                     ' VALUES(:account_id, :id, 0, :active_time, :sub_time, :create_time, :modify_time, :using_id, 0) ' .
                                     ' ON DUPLICATE KEY UPDATE accountid=:account_id, id=:id, lv=0, active_time=:active_time, sub_time=:sub_time, modify_time=:modify_time, using_id=:using_id, exp=0;',
                                     array(
                                         ':account_id' => $account_id,
                                         ':id' => $id,
                                         ':active_time' => 0,
                                         ':create_time' => time(),
                                         ':modify_time' => time(),
                                         ':sub_time' => 0,
                                         ':using_id' => $id,
                                     ));
            if(!$ret){
                die();
                return;
            }
            array_push($equip_list, array(
                'id' => $id,
                'lv' => 0,
                'active_time' => 0,
                'using_id' => $id,
                'exp' => 0,
                'time_flag' => 0,
            ));
        } else {
            if (count($rows) == 1) {
                $id = 0;
                $flag = 0;
                $using_id = 0;
                foreach ($rows as $row) {
                    $e = $this->getEquip($row['id']);
                    if ($e['upgrade_priority'] == '') {
                        $flag = 1;
                    }
                    $id = $addreward->getRealIndexid($row['id'], $account_id);
                    $using_id = $id;
                    if ($flag == 1) {
                        $lv = $row['lv'];
                        $active_time = $row['active_time'] + $row['sub_time'];
                    } else {
                        $lv = 0;
                        $active_time = 0;
                    }
                    $time_flag = 0;
                    if ($flag == 0) {
                        $ret = $conn->execScript('UPDATE equip SET id=:id, lv=0, modify_time=:modify_time, using_id=:id ' .
                                                 ' WHERE accountid=:accountid;',
                                                 array(
                                                     ':accountid' => $account_id,
                                                     ':modify_time' => time(),
                                                     ':id' => $id,
                                                     ':using_id' => $id,
                                                 ));
                    }
                    $time = $row['active_time'] + $row['sub_time'];
                    if (time() >= $time && $row['sub_time'] != 0) {
                        $ret1 = $conn->execScript('UPDATE equip SET active_time=0, sub_time=0, modify_time=:modify_time ' .
                                                  ' WHERE accountid=:accountid AND id=:id;',
                                                  array(
                                                      ':accountid' => $account_id,
                                                      ':modify_time' => time(),
                                                      ':id' => $id,
                                                  ));
                        if (!$ret1) {
                            die();
                            return;
                        }
                        $time = 0;
                        $time_flag = 1;
                        $active_time = 0;
                    }

                    array_push($equip_list, array(
                        'id' => $id,
                        'lv' => $lv,
                        'active_time' => $active_time,
                        'using_id' => $using_id,
                        'exp' => $row['exp'],
                        'time_flag' => $time_flag,
                    ));
                }
                if ($flag == 0) {
                    //更新老玩家数据
                    $g_conf_lot_cluster = require('../res/equip@equip.php');
                    for ($i = 0; $i < count($g_conf_lot_cluster); $i++) {
                        $e = $this->getEquip(12100 + $i);
                        if (!$e || $e['id'] >= $row['id'] || $e['upgrade_priority'] == '') {
                            continue;
                        }
                        $id = $addreward->getRealIndexid($e['id'], $account_id);
                        $ret = $conn->execScript('INSERT INTO equip(accountid, id, lv, active_time, sub_time, create_time, modify_time, using_id, exp) ' .
                                                 ' VALUES(:account_id, :id, :lv, :active_time, :sub_time, :create_time, :modify_time, :using_id, 0) ' .
                                                 ' ON DUPLICATE KEY UPDATE accountid=:account_id, id=:id, lv=:lv, active_time=:active_time, sub_time=:sub_time, modify_time=:modify_time, using_id=:using_id, exp=0;',
                                                 array(
                                                     ':account_id' => $account_id,
                                                     ':id' => $id,
                                                     ':active_time' => 0,
                                                     ':create_time' => time(),
                                                     ':modify_time' => time(),
                                                     ':sub_time' => 0,
                                                     ':using_id' => $using_id,
                                                     ':lv' => 0
                                                 ));
                        if(!$ret){
                            die();
                            return;
                        }
                        array_push($equip_list, array(
                            'id' => $id,
                            'lv' => 0,
                            'active_time' => 0,
                            'using_id' => $using_id,
                            'exp' => 0,
                            'time_flag' => 0,
                        ));
                    }
                }
            } else {
                //装备信息
                foreach ($rows as $row) {
                    $time_flag = 0;
                    $id = $addreward->getRealIndexid($row['id'], $account_id);
                    $time = $row['active_time'] + $row['sub_time'];
                    if (time() >= $time && $row['sub_time'] != 0) {
                        $ret1 = $conn->execScript('UPDATE equip SET active_time=0, sub_time=0, modify_time=:modify_time ' .
                                                  ' WHERE accountid=:accountid AND id=:id;',
                                                  array(
                                                      ':accountid' => $account_id,
                                                      ':modify_time' => time(),
                                                      ':id' => $row['id'],
                                                  ));
                        if (!$ret1) {
                            die();
                            return;
                        }
                        $time = 0;
                        $time_flag = 1;
                    }
                    array_push($equip_list, array(
                        'id' => $id,
                        'lv' => $row['lv'],
                        'active_time' => $time,
                        'using_id' => $row['using_id'],
                        'exp' => $row['exp'],
                        'time_flag' => $time_flag
                    ));
                }
            }
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'equip_list' => $equip_list,
        ));
    }

    public function getEquipInfo()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $equip_list = array();
        $time_flag = 0;
        $row = $conn->execQueryOne('SELECT * FROM equip WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id
                                   ));
        if (!$row) {
            $id = 0;
            $g_conf_lot_cluster = require('../res/equip@equip.php');
            for ($i = 0; $i < count($g_conf_lot_cluster); $i++) {
                $e = $this->getEquip(12100 + $i);
                if (!$e) {
                    continue;
                }
                if ($e['upgrade_priority'] == 1) {
                    $id = $e['id'];
                    break;
                }
            }
            $ret = $conn->execScript('INSERT INTO equip(accountid, id, lv, active_time, sub_time, create_time, modify_time, using_id, exp) ' .
                                     ' VALUES(:account_id, :id, 0, :active_time, :sub_time, :create_time, :modify_time, :using_id, 0) ' .
                                     ' ON DUPLICATE KEY UPDATE accountid=:account_id, id=:id, lv=0, active_time=:active_time, sub_time=:sub_time, modify_time=:modify_time, using_id=:using_id, exp=0;',
                                     array(
                                         ':account_id' => $account_id,
                                         ':id' => $id,
                                         ':active_time' => 0,
                                         ':create_time' => time(),
                                         ':modify_time' => time(),
                                         ':sub_time' => 0,
                                         ':using_id' => $id,
                                     ));
            if(!$ret){
                die();
                return;
            }
            $ret = $conn->execScript('INSERT INTO bag(accountid, id, color_id, status, num, active_time, create_time, modify_time) ' .
                                     ' VALUES(:account_id, :id, 0, :status, 1, :active_time, :create_time, :modify_time) ' .
                                     ' ON DUPLICATE KEY UPDATE accountid=:account_id, id=:id, color_id=0, status=:status, num=1, active_time=:active_time, modify_time=:modify_time;',
                                     array(
                                         ':account_id' => $account_id,
                                         ':id' => 18004,
                                         ':active_time' => 0,
                                         ':status' => 0,
                                         ':create_time' => time(),
                                         ':modify_time' => time()
                                     ));
            array_push($equip_list, array(
                'id' => $id,
                'lv' => 0,
                'active_time' => 0,
                'using_id' => $id,
            ));
        } else {
            $time = $row['active_time'] + $row['sub_time'];
            $using_id = $row['using_id'];
            if (time() >= $row['active_time'] + $row['sub_time'] && $row['sub_time'] != 0) {
                $ret1 = $conn->execScript('UPDATE equip SET active_time=0, sub_time=0, using_id=:using_id, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':modify_time' => time(),
                                             ':using_id' => $row['id'],
                                         ));
                if (!$ret1) {
                    die();
                    return;
                }
                $time = 0;
                $time_flag = 1;
                $using_id = $row['id'];
            }
            array_push($equip_list, array(
                'id' => $row['id'],
                'lv' => $row['lv'],
                'active_time' => $time,
                'using_id' => $using_id,
            ));
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'equip_list' => $equip_list,
            'time_flag' => $time_flag,
        ));
    }

    public function updateEquip()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        $equip_list = array();
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $row = $conn->execQueryOne('SELECT * FROM equip WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id
                                   ));
        $rowUser = $conn->execQueryOne('SELECT coin_num, diamond_num FROM user WHERE accountid=:account_id;',
                                       array(
                                           ':account_id' => $account_id
                                       ));
        if (!$row || !$rowUser) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $e = $this->getEquip($row['id']);
        if (!$e) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个装备');
            return;
        }
        $flag = 0;
        $id = $row['id'];
        if ($row['lv'] < $e['max_level']) {
            //金币升级
            $coin_array = $this->getExplode($e['level_gold_cost']);
            $coin_num = $coin_array[$row['lv']][0];
            if ($rowUser['coin_num'] < $coin_num) {
                phpcommon\sendError(ERR_USER_BASE + 3, '金币不足');
                return;
            }
            $retuser = $conn->execScript('UPDATE user SET coin_num=:coin_num, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':coin_num' => $rowUser['coin_num'] - $coin_num,
                                             ':modify_time' => time()
                                         ));
            $ret = $conn->execScript('UPDATE equip SET lv=:lv, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':lv' => $row['lv'] + 1,
                                         ':modify_time' => time()
                                     ));
            if (!$ret || !$retuser) {
                die();
                return;
            }
        } else {
            //装备进阶
            $rowBag = $conn->execQuery('SELECT * FROM bag WHERE accountid=:account_id AND id>18000 AND id<19000;',
                                       array(
                                           ':account_id' => $account_id
                                       ));
            $max_p = $e['upgrade_priority'];
            $g_conf_lot_cluster = require('../res/equip@equip.php');
            for ($i = 0; $i < count($g_conf_lot_cluster); $i++) {
                $ec = $this->getEquip(12100 + $i);
                if (!$ec) {
                    continue;
                }
                if ($ec['upgrade_priority'] == $max_p + 1) {
                    $id = $ec['id'];
                    break;
                }
            }
            if ($id == $row['id']) {
                phpcommon\sendError(ERR_USER_BASE + 4, '装备已达满级');
                return;
            }
            $mar_array = $this->getExplode($e['equip_upgradematerial']);
            $mflag = 0;
            for ($m = 0; $m < count($mar_array); $m++) {
                foreach ($rowBag as $rb) {
                    if ($rb['id'] == $mar_array[$m][0]) {
                        if ($rb['num'] >= $mar_array[$m][1]) {
                            $mflag++;
                        }
                    }
                }
            }
            if ($mflag < count($mar_array)) {
                phpcommon\sendError(ERR_USER_BASE + 5, '材料不足');
                return;
            }
            //扣除材料
            for ($m = 0; $m < count($mar_array); $m++) {
                foreach ($rowBag as $rb) {
                    if ($rb['id'] != $mar_array[$m][0]) {
                        continue;
                    }
                    $retbag = $conn->execScript('UPDATE bag SET num=:num, modify_time=:modify_time ' .
                                                ' WHERE accountid=:accountid AND id=:id;',
                                                array(
                                                    ':accountid' => $account_id,
                                                    ':num' => $rb['num'] - $mar_array[$m][1],
                                                    ':id' => $rb['id'],
                                                    ':modify_time' => time()
                                                ));
                    if (!$retbag) {
                        die();
                        return;
                    }
                    break;
                }
            }
            $active_time = time();
            $sub_time = $e['equip_upgradetime'];
            $using_id = $row['using_id'];
            if ($e['equip_upgradetime'] == 0) {
                $active_time = 0;
                $flag = 1;
                $using_id = $id;
            }
            $retEquip = $conn->execScript('UPDATE equip SET id=:id, lv=0, active_time=:active_time, using_id=:using_id, sub_time=:sub_time, modify_time=:modify_time ' .
                                          ' WHERE accountid=:accountid;',
                                          array(
                                              ':accountid' => $account_id,
                                              ':id' => $id,
                                              ':modify_time' => time(),
                                              ':active_time' => $active_time,
                                              ':sub_time' => $sub_time,
                                              ':using_id' => $using_id,
                                          ));
            if (!$retEquip) {
                die();
                return;
            }
        }
        $addreward = new classes\AddReward();
        $coin_num = $addreward->getCoinNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'coin_nums' => $coin_num,
            'flag' => $flag,
            'id' => $id,
        ));
    }

    public function  speedUpTime()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $id = 0;
        if (isset($_REQUEST['id'])) {
            $id = $_REQUEST['id'];
        }

        $type = $_REQUEST['type'];
        $row = $conn->execQueryOne('SELECT * FROM equip WHERE accountid=:account_id AND id=:id;',
                                   array(
                                       ':account_id' => $account_id,
                                       ':id' => $id
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }

        $e = $this->getEquip($id);
        if (!$e) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个装备');
            return;
        }
        $view_list = $this->getExplode($e['reduce_time']);
        $reduce_time = $view_list[$row['lv'] - 1][0];
        $flag = 0;
        //error_log($e['reduce_time']);
        $sub_time = $row['sub_time'] - floor($row['sub_time'] * $reduce_time * 0.01);
        if ($type == 1) {
            $rowUser = $conn->execQueryOne('SELECT diamond_num FROM user WHERE accountid=:account_id;',
                                           array(
                                               ':account_id' => $account_id
                                           ));
            if (!$rowUser) {
                phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
                return;
            }
            $diamond_arr = $this->getExplode($e['diamond_cost']);
            $diamond_cost = $diamond_arr[$row['lv'] - 1][0];
            if ($rowUser['diamond_num'] < $diamond_cost) {
                phpcommon\sendError(ERR_USER_BASE + 3, '钻石不足');
                return;
            }
            $diamond_list = $this->getExplode($e['diamond_time']);
            $diamond_time = $diamond_list[$row['lv'] - 1][0];
            $sub_time = $row['sub_time'] - floor($row['sub_time'] * $diamond_time * 0.01);
            $retUser = $conn->execScript('UPDATE user SET diamond_num=:diamond_num, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':diamond_num' => $rowUser['diamond_num'] - $diamond_cost,
                                             ':modify_time' => time()
                                         ));
            if (!$retUser) {
                die();
                return;
            }
            $rechargeactivity = new classes\RechargeActivity();
            $rechargeactivity->triggerConsume($account_id, $diamond_cost);
        }
        $active_time = $row['active_time'];
        if ($active_time + $sub_time <= time() ||
            $active_time + $row['sub_time'] <= time() + 30) {
            $active_time = 0;
            $sub_time  = 0;
            $flag = 1;
        }
        $retEquip = $conn->execScript('UPDATE equip SET active_time=:active_time, sub_time=:sub_time, modify_time=:modify_time ' .
                                      ' WHERE accountid=:accountid AND id=:id;',
                                      array(
                                          ':accountid' => $account_id,
                                          ':active_time' => $active_time,
                                          ':sub_time' => $sub_time,
                                          ':modify_time' => time(),
                                          ':id' => $id,
                                      ));
        if (!$retEquip) {
            die();
            return;
        }
        $addreward = new classes\AddReward();
        $num = $addreward->getDiamondNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'diamond_nums' => $num,
            'flag' => $flag,
            'id' => $row['id'],
            'lv' => $row['lv'],
        ));
    }

    public function exchangeEquip()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $equip_id = $_REQUEST['id'];
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $row = $conn->execQueryOne('SELECT id, using_id FROM equip WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        if ($equip_id > $row['id']) {
            phpcommon\sendError(ERR_USER_BASE + 3, '武器未获得');
            return;
        }
        $ret = $conn->execScript('UPDATE equip SET using_id=:using_id, modify_time=:modify_time ' .
                                 ' WHERE accountid=:accountid;',
                                 array(
                                     ':accountid' => $account_id,
                                     ':using_id' => $equip_id,
                                     ':modify_time' => time(),
                                 ));
        if (!$ret) {
            die();
            return;
        }

        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'using_id' => $equip_id,
        ));
    }

    public function exchangeNewEquip()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $equip_id = $_REQUEST['id'];
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $row = $conn->execQueryOne('SELECT * FROM equip WHERE accountid=:account_id AND id=:id;',
                                   array(
                                       ':account_id' => $account_id,
                                       ':id' => $equip_id
                                   ));
        $lv = 0;
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 3, '武器未获得');
            return;
        } else {
            $lv = $row['lv'];
        }

        $ret = $conn->execScript('UPDATE equip SET using_id=:using_id, modify_time=:modify_time ' .
                                 ' WHERE accountid=:accountid;',
                                 array(
                                     ':accountid' => $account_id,
                                     ':using_id' => $equip_id,
                                     ':modify_time' => time(),
                                 ));
        if (!$ret) {
            die();
            return;
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'using_id' => $equip_id,
            'lv' => $lv,
            'active_time' => $row['active_time'] + $row['sub_time'],
        ));
    }

    public function shengjiEquip()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $equip_id = $_REQUEST['id'];
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $e = $this->getEquip($equip_id);
        if (!$e) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个装备');
            return;
        }
        $upgrade_gold = $e['upgrade_gold'];
        $drop_multiply = explode('&', $upgrade_gold);
        $arr = array();
        for ($i = 0; $i < count($drop_multiply); $i++) {
            $mul = explode('|', $drop_multiply[$i]);
            array_push($arr, $mul);
        }
        $row = $conn->execQueryOne('SELECT id, lv, exp FROM equip WHERE accountid=:account_id AND id=:id;',
                                   array(
                                       ':account_id' => $account_id,
                                       ':id' => $equip_id
                                   ));
        $item_id_arr = array();
        $item_num_arr = array();
        $exp = 0;
        $lv = 0;
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 3, '武器未获得');
            return;
        } else {
            $lv = $row['lv'];
            $exp = $row['exp'];
        }

        if ($lv >= $e['max_level']) {
            phpcommon\sendError(ERR_USER_BASE + 5, '达到最大等级');
            return;
        }
        $arr2 = array();
        $str = $arr[$lv][0];
        $estr = explode(';', $str);
        $val = $estr[1];
        if ($lv > 0) {
            $str1 = $arr[$lv - 1][0];
            $estr1 = explode(';', $str1);
            $val = $estr[1] - $estr1[1];
        }
        if ($val <= $exp) {
            phpcommon\sendError(ERR_USER_BASE + 4, '当前等级经验已满');
            return;
        }
        for ($a1 = 0; $a1 < count($arr[$lv]); $a1++) {
            $mul2 = explode(';', $arr[$lv][$a1]);
            array_push($arr2, $mul2);
        }

        $arr3 = array();
        for ($ii = 0; $ii < count($arr2); $ii++) {
            for ($a2 = 0; $a2 < count($arr2[$ii]); $a2++) {
                $mul3 = explode(':', $arr2[$ii][$a2]);
                if (count($mul3) > 1) {
                    array_push($arr3, $mul3);
                }
            }
        }
        foreach ($arr3 as $ar) {
            $it = $this->getItem($ar[0]);
            if (!$it) {
                phpcommon\sendError(ERR_USER_BASE + 1, '没有这个道具');
                return;
            }
            $rowuser = $conn->execQueryOne('SELECT coin_num, diamond_num FROM user WHERE accountid=:account_id;',
                                           array(
                                               ':account_id' => $account_id,
                                           ));
            if (!$rowuser) {
                phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
                return;
            }

            if ($it['type'] == 1) {
                if ($ar[1] > $rowuser['coin_num']) {
                    phpcommon\sendError(ERR_USER_BASE + 3, '金币不足');
                    return;
                }
            } else if ($it['type'] == 3) {
                if ($ar[1] > $row['diamond_num']) {
                    phpcommon\sendError(ERR_USER_BASE + 4, '钻石不足');
                    return;
                }
            } else if ($it['type'] == 11) {
                $rowbag = $conn->execQueryOne('SELECT num FROM bag WHERE accountid=:accountid AND id=:id;',
                                              array(
                                                  ':accountid' => $account_id,
                                                  'id' => $ar[0]
                                              ));
                if ($ar[1] > $rowbag['num']) {
                    phpcommon\sendError(ERR_USER_BASE + 5, '道具不足');
                    return;
                }
            }
        }
        foreach ($arr3 as $ar1) {
            $this->subCoin($ar1[0], $ar1[1], $account_id);
        }

        $ret = $conn->execScript('UPDATE equip SET exp=:exp, modify_time=:modify_time ' .
                                 ' WHERE accountid=:accountid AND id=:id;',
                                 array(
                                     ':accountid' => $account_id,
                                     ':id' => $equip_id,
                                     ':modify_time' => time(),
                                     ':exp' => $exp + 1,
                                 ));
        if (!$ret) {
            die();
            return;

        }
        $addreward = new classes\AddReward();
        $coin_num = $addreward->getCoinNum($account_id);
        $num = $addreward->getDiamondNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'exp' => $exp + 1,
            'coin_nums' => $coin_num,
            'diamond_nums' => $num,
            'lv' => $lv,
        ));
    }

    protected function subCoin($item_id, $item_num, $account_id)
    {
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            die();
            return;
        }

        $row = $conn->execQueryOne('SELECT coin_num, diamond_num FROM user WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id,
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            die();
            return;
        }

        $it = $this->getItem($item_id);
        if (!$it) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个道具');
            die();
            return;
        }

        if ($item_id != 0){
            if ($it['type'] == 1) {
                $ret = $conn->execScript('UPDATE user SET coin_num=:coin_num, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':modify_time' => time(),
                                             ':coin_num' => $row['coin_num'] - $item_num,
                                         ));
                if (!$ret) {
                    die();
                    return;
                }
            } else if ($it['type'] == 3) {
                $ret = $conn->execScript('UPDATE user SET diamond_num=:diamond_num, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':modify_time' => time(),
                                             ':diamond_num' => $row['diamond_num'] - $item_num,
                                         ));
                if (!$ret) {
                    die();
                    return;
                }
                $rechargeactivity = new classes\RechargeActivity();
                $rechargeactivity->triggerConsume($account_id, $item_num);
            } else if ($it['type'] == 11) {
                $rowbag = $conn->execQueryOne('SELECT num FROM bag WHERE accountid=:accountid AND id=:id;',
                                              array(
                                                  ':accountid' => $account_id,
                                                  'id' => $item_id
                                              ));
                $ret = $conn->execScript('UPDATE bag SET num=:num, modify_time=:modify_time ' .
                                         ' WHERE accountid=:accountid AND id=:id;',
                                         array(
                                             ':accountid' => $account_id,
                                             ':modify_time' => time(),
                                             ':num' => $rowbag['num'] - $item_num,
                                             ':id' => $item_id
                                         ));
                if (!$ret) {
                    die();
                    return;
                }
            }
        }
    }

    public function jinjieEquip()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $equip_id = $_REQUEST['id'];
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }
        $row = $conn->execQueryOne('SELECT id, using_id, lv, exp FROM equip WHERE accountid=:account_id AND id=:id;',
                                   array(
                                       ':account_id' => $account_id,
                                       ':id' => $equip_id
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 3, '武器未获得');
            return;
        }

        $lv = $row['lv'];
        $e = $this->getEquip($equip_id);
        if (!$e) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个装备');
            return;
        }
        $upgrade_gold = $e['upgrade_gold'];
        $drop_multiply = explode('&', $upgrade_gold);
        $arr = array();
        for ($i = 0; $i < count($drop_multiply); $i++) {
            $mul = explode('|', $drop_multiply[$i]);
            array_push($arr, $mul);
        }
        $arr2 = array();
        $flag = 0;
        $valexp = 0;
        if ($lv == 0) {
            $str = $arr[$lv][0];
            $estr = explode(';', $str);
            $valexp = $estr[1];
        } else {
            $str1 = $arr[$lv][0];
            $estr1 = explode(';', $str1);
            $str = $arr[$lv - 1][0];
            $estr = explode(';', $str);
            $valexp = $estr1[1] - $estr[1];
        }
        if ($valexp > $row['exp']) {
            phpcommon\sendError(ERR_USER_BASE + 4, '未达到进阶需求');
            return;
        }

        if ($lv >= $e['max_level']) {
            phpcommon\sendError(ERR_USER_BASE + 5, '达到最大等级');
            return;
        }
        $coinarr =  explode('|', $e['promote_gold']);
        $key = $lv;
        $coin_num = $coinarr[$key];
        $row = $conn->execQueryOne('SELECT coin_num, diamond_num FROM user WHERE accountid=:account_id;',
                                   array(
                                       ':account_id' => $account_id,
                                   ));
        if (!$row) {
            phpcommon\sendError(ERR_USER_BASE + 2, '没有这个玩家');
            return;
        }

        if ($coin_num > $row['coin_num']) {
            phpcommon\sendError(ERR_USER_BASE + 3, '金币不足');
            return;
        }
        
        $jinjieinfo = explode('|', $e['promote_material']);
        if ($key >= count($jinjieinfo)) {
            phpcommon\sendError(ERR_USER_BASE + 4, '已经满阶');
            return;
        }
        
        $curjinjie = explode(';', $jinjieinfo[$key]);
        $jinjieitems = array();
        foreach( $curjinjie as $jinjieitemstr) {
            $mar_array = explode(':', $jinjieitemstr);
            $mid = $mar_array[0];
            $mnum = $mar_array[1];
            $rbag = $conn->execQueryOne('SELECT num FROM bag WHERE accountid=:account_id AND id=:id;',
                                        array(
                                            ':account_id' => $account_id,
                                            ':id' => $mid,
                                        ));

            if (!$rbag || $rbag['num'] < $mnum) {
                phpcommon\sendError(ERR_USER_BASE + 6, '材料不足');
                return;
            }

            $jinjieitems[] = array(
                "item_id" => $mid,
                "item_num" => $mnum,
            );
        }        

        $this->subCoin(10001, $coin_num, $account_id);
        foreach($jinjieitems as $jinjie_item) {
            $mid = $jinjie_item['item_id'];
            $mnum = $jinjie_item['item_num'];
            $this->subCoin($mid, $mnum, $account_id);
        }

        $active_time = time();
        $sub_list = $this->getExplode($e['equip_upgradetime']);
        $sub_time = $sub_list[$lv][0];
        if ($sub_time == 0) {
            $active_time = 0;
            $flag = 1;
        }
        $ret = $conn->execScript('UPDATE equip SET exp=:exp, lv=:lv, modify_time=:modify_time, active_time=:active_time, sub_time=:sub_time ' .
                                 ' WHERE accountid=:accountid AND id=:id;',
                                 array(
                                     ':accountid' => $account_id,
                                     ':id' => $equip_id,
                                     ':modify_time' => time(),
                                     ':exp' => 0,
                                     ':lv' => $lv + 1,
                                     ':active_time' => $active_time,
                                     ':sub_time' => $sub_time
                                 ));
        if (!$ret) {
            die();
            return;
        }
        $addreward = new classes\AddReward();
        $coin_num = $addreward->getCoinNum($account_id);
        $num = $addreward->getDiamondNum($account_id);
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'exp' => 0,
            'lv' => $lv + 1,
            'coin_nums' => $coin_num,
            'diamond_nums' => $num,
            'flag' => $flag,
            'id' => $equip_id,
        ));
    }
}
?>
